module_name = "HTML AutoInclude";
module_ver = "0.3";
// Code copyright 2006-2007 T. Pattison. Please contact me via
// geniscope.atspace.com with any ammendments or enhancements to this
// script.

// This script updates the contents of the project's HTML files with matching
// blocks within the "include.html" file.
// This script expects a file called "include.html" to be present within
// the open project.
// Blocks are identified by pairs of HTML comments (see included sample file):
// <!-- name -->[newline]X number of Lines of HTML[newline]<!-- Endname -->
// Script takes named comment from include.html and searches for the same
// comment within the current file.

function GetBlocks(){
  files=getfiles();
  logClear();
  if (files[0]==null) {logAddLine("Error: Cant find include.html"); return;}
  var obj2 = newEditor();
  obj2.openFile(files[0]);
  obj2.command("ecNormalSelect");
  iText = obj2.Text();
  ilines = iText.split("\n");

  for (var pf=1; pf<files.length; pf++){
  
  var editor = newEditor();
  editor.openFile(files[pf]);
  curFile=files[pf];
  logAddLine("Updating: "+curFile);
  
  var inBlk=0;
  for (var ii=0; ii<ilines.length; ii++) {
    if (inBlk==0) { 
    obj2.setCaretPos(0,ii+1);   
      if (ilines[ii].indexOf("<!-- ")>=0) {
        if (ilines[ii].indexOf("<!-- End")==-1) {
          var cmtEnd=ilines[ii].indexOf("->");
          Blk=ilines[ii].substring(5,(cmtEnd-2));
          logAddLine("Finding: *"+Blk+"*");
          inBlk=1;
        }
        else {logAddLine("Error: Bad include.html");}
      }
    }
    if (inBlk==1) {
      if (ilines[ii].indexOf("<!-- End"+Blk)>=0) {
        inBlk=0;
        obj2.command("ecSelLineEnd");
        //ready to copy
        obj2.command("ecCopy");
        GotoMark(Blk);
      }
      else {obj2.command("ecSelDown");}
    }
  }
  if (inBlk==1){logAddLine("Error: Bad include.html: end of file before end comment found");}
  editor=null;
  
  }
  
  obj2 = null;
  logAddLine("Done!");
}

function getfiles() {
  files=new Array();
  var hf=1;
  for (var pf=0; pf<projectFilesCount(); pf++){
    fnamel=projectFiles(pf).length;
    fnameext=projectFiles(pf).substring(fnamel, fnamel-4);
    if (fnameext=="html"||fnameext==".htm"||fnameext==".php") {
      if (projectFiles(pf).substring(fnamel, fnamel-12)!="include.html") {
        files[hf]=projectFiles(pf);
        hf+=1;
      }
      else {files[0]=projectFiles(pf);}
    }
  }
  return files;
}


function GotoMark(Blk){
    pattern = "<!-- "+Blk+" -->";
    stPos = GetStrPos(pattern);
    pattern = "<!-- End"+Blk+" -->";
    enPos = GetStrPos(pattern);
    var editor = newEditor();
    editor.assignEditorByName(curFile);
    editor.command("ecLineStart");    
    editor.command("ecNormalSelect");
    if(enPos>stPos && stPos>=0 && enPos>=0){
        editor.setCaretPos(0,stPos);
        for (var kk=0; kk<(enPos-stPos); kk++) {
            editor.command("ecSelDown");
        }
        editor.command("ecSelLineEnd");
        editor.command("ecPaste");
    }
    else{
        logAddLine("No match found for "+Blk);
    }
    editor = null;
}

function GetStrPos(pattern){
    var editors = newEditor();
    editors.assignEditorByName(curFile);
    allText = editors.Text();
    lines = allText.split("\n");
    var iPos=0;
    var StrPosn = -1;
    for (var jj=0; jj<lines.length; jj++) {
        iPos = lines[jj].indexOf(pattern);
        if(iPos != -1){
            StrPosn = jj+1;
            logAddLine("Valid comment found at line "+StrPosn);
            return (StrPosn);
            break;
        }
    }
    editors = null;
}

function Init(){
  addMenuItem("Update Include", "HTML AutoInclude", "GetBlocks");
}